//------------------------------------------------------------------
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_color2  DarkGray
#property indicator_color3  DarkGray
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width1  2

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern int    MaPeriod      = 20;
extern int    MaPrice       = PRICE_CLOSE;
extern double AtrMultiplier = 1.0;
extern bool   Interpolate   = true;

double ema[];
double bandu[];
double bandd[];
double atravg[];
double prices[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,ema);
      SetIndexBuffer(1,bandu);
      SetIndexBuffer(2,bandd);
      SetIndexBuffer(3,atravg);
      SetIndexBuffer(4,prices);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
               
   IndicatorShortName(timeFrameToString(timeFrame)+" adaptive atr channel ("+MaPeriod+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int n,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ema[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
    
   if (calculateValue || timeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         prices[i] = iMA(NULL,0,1,0,MODE_SMA,MaPrice,i);
         double minPeriod = MaPeriod/2.0;
         double maxPeriod = minPeriod*5.0;
         double signal    = MathAbs(prices[i]-prices[i+MaPeriod]);
         double noise     = 0.00000000001;

               //
               //
               //
               //
               //
               
                     for(int k=0; k<MaPeriod; k++) noise += MathAbs(prices[i+k]-prices[i+k+1]);
               
               //
               //
               //
               //
               //

         double averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
         double alpha         = 2.0 / (1.0+averagePeriod);
         double atr           = iATR(NULL,0,averagePeriod,i);

         //
         //
         //
         //
         //
         
         atravg[i] = atravg[i+1]+alpha*(atr-atravg[i+1]);
         ema[i]    = ema[i+1]+alpha*(prices[i]-ema[i+1]);
         bandu[i]  = ema[i]+AtrMultiplier*atravg[i];
         bandd[i]  = ema[i]-AtrMultiplier*atravg[i];
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ema[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaPrice,AtrMultiplier,0,y);
         bandu[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaPrice,AtrMultiplier,1,y);
         bandd[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaPrice,AtrMultiplier,2,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(k = 1; k < n; k++)
               {
                  ema[i+k]   = ema[i]   + (ema[i+n]   - ema[i]  )*k/n;
                  bandu[i+k] = bandu[i] + (bandu[i+n] - bandu[i])*k/n;
                  bandd[i+k] = bandd[i] + (bandd[i+n] - bandd[i])*k/n;
               }                  
   }
   
   //
   //
   //
   //
   //

   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}